# This file contains a JSONSchema to validate the values given
# as inputs to the chart.
#
# **** How to edit this file *****
#
# This file is encoded as YAML instead of JSON to allow comments,
# and make editing and diffing easier.
#
# The values.schema.json file is the file actually used by the Helm chart
# and MUST BE RECREATED after each modification of this file:
#
#   ./utils/_yaml2json.py < values.schema.yaml > values.schema.json
#
# You can test that this file is a valid JSONSchema with:
#
#   utils/_yaml2json.py < values.schema.yaml > values.schema.json && python -m jsonschema -o pretty /usr/lib/python3/dist-packages/jsonschema/schemas/draft2020-12.json -i values.schema.json
#
# **** How to test that values.yaml files conform to this schema ****
#
# Helm template will do this validation:
#
#  utils/_yaml2json.py < values.schema.yaml > values.schema.json && helm template . --values values.yaml
#
# You can also use another JSONSchema validation tool (it's useful to have more detailed answers than what Helm produces):
#
#   To test the chart default values.yaml:
#
#      utils/_yaml2json.py < values.schema.yaml > values.schema.json && \
#        utils/_yaml2json.py < values.yaml | python -m jsonschema -o pretty values.schema.json -i /dev/stdin
#
#   To test the combination of the default values.yaml combined with other values files:
#
#      utils/_yaml2json.py < values.schema.yaml > values.schema.json && \
#        utils/_yaml-merge.py -o json values.yaml foo.yaml | python -m jsonschema -o pretty values.schema.json -i /dev/stdin
#

$schema: https://json-schema.org/draft-07/schema#

title: Schema for sriov-resources chart values

$defs: {}

# this description is formatted so that it will appear very clearly
# in the JSON counterpart that the JSON isn't meant to be edited

additionalProperties: false

properties:
  defaults:
    type: object
  node_policies:
    type: object
    patternProperties:
      "^(?:/([a-zA-Z0-9/.-]+)|(?:[a-z0-9][a-z0-9-]*[a-z0-9]))$":
        additionalProperties: true
        type: object
        properties:
          nicSelector:
            type: object
            properties:
              deviceID:
                type: string
              netFilter:
                type: string
              pfNames:
                type: array
                items:
                  type: string
              rootDevices:
                type: array
                items:
                  type: string
              vendor:
                type: string
          nodeSelector:
            type: object
          numVfs:
            minimum: 0
            type: integer
          resourceName:
            type: string
        required:
        - nicSelector
        - numVfs
        - resourceName
